import java.util.*;

public class Scheme 
{ 
    public static Scheme instance;

    static final int MAP_CELL = 100;
    static final int MAP_WIDTH = 600;
    static final int MAP_HEIGHT = 600;

    Line[] metroLines; 
    Cross[] metroCrosses;

    public Scheme(String schemeDefinition) { 
        metroLines = new Line[]{
            new Line("", 0xFF0000, new int[]{2*60, 1*60+30, 6*60}, new Station[]{
                         new Station(" ", 2*60, 486, 3),
                         new Station("", 4*60, 486, 14),
                         new Station(" ", 3*60, 486, 26),
                         new Station("", 2*60, 486, 36),
                         new Station("", 2*60, 486, 47),
                         new Station("[]", 2*60, 382, 207),
                         new Station(" ", 1*60, 368, 221),
                         new Station(" ", 2*60, 349, 239),
                         new Station("", 1*60+30, 321, 268),
                         new Station(" ", 1*60+40, 285, 304),
                         new Station(" .", 1*60+40, 231, 357),
                         new Station("", 2*60+10, 205, 384),
                         new Station(" []", 2*60+20, 192, 397),
                         new Station("", 1*60+40, 83, 531),
                         new Station("", 2*60+40, 83, 542),
                         new Station(" ", 3*60+20, 83, 553),
                         new Station("", 2*60+50, 83, 564),
                         new Station(" ", 3*60, 83, 575),
                         new Station("-", 0, 83, 591)
                     }), 
            new Line("", 0x00D080, new int[]{2*60, 2*60, 6*60}, new Station[]{
                         new Station(" ", 2*60, 187, 3),
                         new Station(" ", 3*60, 187, 14),
                         new Station("", 3*60, 187, 25),
                         new Station("", 2*60, 187, 36),
                         new Station("", 3*60, 187, 47),
                         new Station("", 3*60, 187, 58),
                         new Station("[]", 2*60, 221, 187),
                         new Station("", 2*60, 225, 213),
                         new Station("", 2*60, 225, 241),
                         new Station("", 3*60, 294, 313),
                         new Station("", 2*60, 329, 347),
                         new Station("[]", 3*60, 380, 399),
                         new Station("", 5*60, 386, 414),
                         new Station("", 4*60, 386, 425),
                         new Station("[2]", 3*60, 386, 438),
                         new Station("", 2*60, 386, 544),
                         new Station("", 3*60, 386, 555),
                         new Station("", 2*60, 386, 566),
                         new Station("", 3*60, 386, 577),
                         new Station("", 0, 386, 593)
                     }), 
            new Line("-", 0x0000FF, new int[]{3*60, 2*60, 5*60}, new Station[]{
                         new Station("", 2*60, 501, 115),
                         new Station("", 3*60, 501, 126),
                         new Station("", 3*60, 501, 137),
                         new Station(" ", 3*60, 501, 148),
                         new Station("", 2*60, 501, 159),
                         new Station("", 3*60, 501, 170),
                         new Station("", 3*60, 501, 181),
                         new Station("[3]", 3*60, 417, 265),
                         new Station(" ", 2*60, 303, 322),
                         new Station("[3]", 2*60, 225, 367),
                         new Station("[3]", 2*60, 169, 340),
                         new Station("[3]", 4*60, 154, 325),
                         new Station(" [3]", 0, 83, 308)
                     }), 
            new Line("", 0x00FFFF, new int[]{3*60, 2*60, 6*60}, new Station[]{
                         new Station("", 3*60, 83, 101),
                         new Station("", 3*60, 83, 112),
                         new Station("", 2*60, 83, 123),
                         new Station("", 2*60, 83, 138),
                         new Station("", 2*60, 83, 162),
                         new Station(" ", 3*60, 83, 173),
                         new Station("", 3*60, 83, 184),
                         new Station("", 2*60, 83, 195),
                         new Station("", 2*60, 83, 206),
                         new Station("", 2*60, 83, 217),
                         new Station("[4]", 2*60, 154, 325),
                         new Station("[4]", 1*60, 188, 326),
                         new Station("[4]", 1*60, 203, 341),
                         new Station(" ", 0, 219, 357),
                     }),
            new Line("", 0x804000, new int[]{2*60, 1*60, 5*60}, new Station[]{
                         new Station(" []", 3*60, 192, 397),
                         new Station("[]", 2*60, 237, 427),
                         new Station("", 3*60, 286, 435),
                         new Station("[]", 3*60, 380, 399),
                         new Station("[]", 3*60, 410, 357),
                         new Station("[]", 3*60, 417, 265),
                         new Station("[]", 3*60, 382, 207),
                         new Station(" []", 4*60, 349, 182),
                         new Station("", 2*60, 261, 172),
                         new Station("[]", 3*60, 221, 187),
                         new Station("", 3*60, 183, 216),
                         new Station("[]", 3*60, 154, 325)
                     }), 
            new Line("-", 0xFFC040, new int[]{2*60, 1*60+30, 6*60}, new Station[]{
                         new Station("", 3*60, 386, 3),
                         new Station("", 2*60, 386, 14),
                         new Station("", 2*60, 386, 25),
                         new Station(" ", 3*60, 386, 37),
                         new Station("", 2*60, 386, 47),
                         new Station("", 3*60, 386, 59),
                         new Station("", 2*60, 386, 69),
                         new Station(" []", 2*60, 349, 181),
                         new Station("", 2*60, 349, 213),
                         new Station("", 2*60, 349, 251),
                         new Station("-[6]", 3*60, 349, 298),
                         new Station("[5]", 3*60, 318, 347),
                         new Station("[]", 2*60, 237, 427),
                         new Station("", 3*60, 187, 487),
                         new Station(" ", 3*60, 187, 498),
                         new Station("", 2*60, 187, 509),
                         new Station("", 2*60, 187, 520),
                         new Station(" ", 3*60, 187, 531),
                         new Station("", 2*60, 187, 542),
                         new Station("", 2*60, 187, 553),
                         new Station("", 4*60, 187, 564),
                         new Station(" ", 3*60, 187, 575),
                         new Station("", 2*60, 187, 586),
                         new Station(" ", 0, 187, 597)
                     }), 
            new Line("-", 0xFF00FF, new int[]{3*60, 1*60, 5*60}, new Station[]{
                         new Station("", 2*60, 172, 80),
                         new Station("", 3*60, 172, 91),
                         new Station("", 4*60, 172, 102),
                         new Station("", 3*60, 172, 113),
                         new Station(" ", 3*60, 172, 124),
                         new Station("", 2*60, 172, 135),
                         new Station("", 2*60, 172, 146),
                         new Station(" 1905 ", 2*60, 172, 157),
                         new Station("", 3*60, 175, 208),
                         new Station("", 2*60, 219, 251),
                         new Station(" ", 2*60, 313, 260),
                         new Station("-[7]", 3*60, 350, 297),
                         new Station("[]", 2*60, 410, 357),
                         new Station("", 2*60, 452, 399),
                         new Station(" ", 4*60, 486, 516),
                         new Station("", 3*60, 486, 527),
                         new Station("", 3*60, 486, 538),
                         new Station(" ", 2*60, 486, 549),
                         new Station("", 0, 486, 560)
                     }), 
            new Line("", 0xFFFF00, new int[]{3*60, 2*60, 6*60}, new Station[]{
                         new Station("", 2*60, 501, 228),
                         new Station("", 3*60, 501, 239),
                         new Station(" ", 2*60, 501, 250),
                         new Station("", 3*60, 501, 261),
                         new Station(" ", 2*60, 452, 310),
                         new Station("", 2*60, 414, 344),
                         new Station("[8]", 0, 318, 347)
                     }), 
            new Line("-", 0xC0C0C0, new int[]{3*60, 2*60, 6*60}, new Station[]{
                         new Station("", 3*60, 312, 3),
                         new Station("", 3*60, 312, 14),
                         new Station("", 3*60, 312, 25),
                         new Station("", 3*60, 312, 36),
                         new Station("-", 3*60, 286, 78),
                         new Station("", 2*60, 261, 113),
                         new Station("", 3*60, 261, 124),
                         new Station("", 2*60, 261, 135),
                         new Station("", 2*60, 261, 160),
                         new Station(" ", 2*60, 281, 191),
                         new Station("", 3*60, 231, 251),
                         new Station("", 2*60, 237, 367),
                         new Station("", 2*60, 286, 417),
                         new Station("", 3*60, 286, 447),
                         new Station("", 4*60, 286, 469),
                         new Station("", 2*60, 286, 480),
                         new Station("", 2*60, 286, 491),
                         new Station(" ", 2*60, 286, 502),
                         new Station("", 2*60, 286, 518),
                         new Station("", 3*60, 286, 536),
                         new Station("", 2*60, 286, 547),
                         new Station("", 3*60, 286, 558),
                         new Station("  ", 2*60, 286, 569),
                         new Station("", 2*60, 286, 580),
                         new Station("  ", 0, 286, 596)
                     }), 
            new Line("", 0x80FF80, new int[]{3*60, 3*60, 6*60}, new Station[]{
                         new Station("", 3*60, 419, 277),
                         new Station("", 3*60, 452, 322),
                         new Station(" ", 2*60, 452, 387),
                         new Station("", 2*60, 404, 506),
                         new Station("", 4*60, 404, 517),
                         new Station("", 3*60, 404, 528),
                         new Station("", 3*60, 404, 540),
                         new Station("", 3*60, 404, 550),
                         new Station("", 2*60, 404, 560),
                         new Station("", 0, 404, 572)
                     }), 
            new Line("", 0x40C0C0, new int[]{5*60, 3*60, 10*60}, new Station[]{
                         new Station("[11]", 3*60, 386, 438),
                         new Station("", 3*60, 361, 461),
                         new Station("", 0, 298, 518)
                     })
        };


        metroCrosses = new Cross[] {
            new Cross("[4]", "[]", 4*60),
            new Cross("[3]", "[4]", 3*60),
            new Cross("[]", "[3]", 2*60),
            new Cross("", "", 2*60),
            new Cross("[]", "[]", 2*60),
            new Cross("", "", 2*60),
            new Cross(" []", " []", 3*60),
            new Cross("[]", "[]", 5*60),
            new Cross("[3]", "[]", 3*60),
            new Cross("", "[]", 4*60),
            new Cross("", "[3]", 2*60),
            new Cross("", "", 3*60),
            new Cross("", "", 3*60),
            new Cross("", "", 2*60),
            new Cross(" ", "", 3*60),
            new Cross(" ", "", 3*60),
            new Cross("", " ", 4*60),
            new Cross("", " ", 3*60),
            new Cross(" ", " ", 6),
            new Cross("-[6]", "-[7]", 1*60),
            new Cross("", "[5]", 2*60),
            new Cross("", "[8]", 2*60),
            new Cross("[5]", "[8]", 1*60),
            new Cross(" ", "[3]", 3*60),
            new Cross(" .", "", 5*60),
            new Cross("", "[3]", 2*60),
            new Cross("[3]", " .", 4*60),
            new Cross(" .", " ", 2*60),
            new Cross(" []", " []", 4*60),
            new Cross("[]", "[]", 2*60),
            new Cross("", "", 2*60),
            new Cross("[]", "[]", 3*60),
            new Cross("[]", "[]", 2*60),
            new Cross("[]", "", 3*60),
            new Cross("[]", "", 2*60),
            new Cross("", " ", 2*60),
            new Cross("", " ", 3*60),
            new Cross("", "", 1*60),
            new Cross("[2]", "[11]", 1*60)
        };
        instance = this;
    }

    /*
    public Scheme(String schemeDefinition) { 
        XMLParser parser = new XMLParser(schemeDefinition);
        Enumeration e = parser.enumerateRootSiblings("scheme");
        Vector lines = new Vector();
        Vector crosses = new Vector();
        while (e.hasMoreElements()) { 
            XMLElement elem = (XMLElement)e.nextElement();
            String name = elem.getName();
            if (name.equals("line")) { 
                XMLElement station = elem.getSibling("station");
                int n = station.getCounter();
                Station[] stations = new Station[n];
                for (int i = 0; i < n; i++) { 
                    stations[i] = new Station(station.getStringAttribute("name"),
                                              station.getIntAttribute("time"),
                                              station.getIntAttribute("x"),
                                              station.getIntAttribute("y"));
                }
                Line line = new Line(elem.getStringAttribute("name"), stations);
                lines.addElement(line);
            } else if (name.equals("cross")) {
                crosses.addElement(new Cross(elem.getStringAttribute("from"),
                                             elem.getStringAttribute("to"),
                                             elem.getIntAttribute("time")));
            }
        }
        metroLines = new Line[lines.size()];
        for (int i = 0; i < metroLines.length; i++) { 
            metroLines[i] = (Line)lines.elementAt(i);
        }
        metroCrosses = new Cross[crosses.size()];
        for (int i = 0; i < metroCrosses.length; i++) { 
            metroCrosses[i] = (Cross)crosses.elementAt(i);
        }
        instance = this;
    }
    */
}
